#!/usr/bin/perl 
#
# This ev = engineering version
# Send a life sign upon a "knock knock", meaning:
#
# User mails a message containing
# Header = ---- knock knock ----
# System will reply with the current time.
# If a message is notreceived after 150 seconds, something is wrong.
#
# Still missing: assign $query{'MyEmail'} = senders email = returning address.
use strict;
use diagnostics;

sub get_stations {
    my   $i;
    my   $line = $_[0];
    my   $NUM = '-?\d+\.?\d*';
    our  (@query,%query);

    $i = $query{"nstations"};
    if ($line =~ /(.+)[\t\s]+($NUM)[\t\s]+($NUM)[\t\s]+($NUM)/) {
        $query[$i]{"Name"}      = $1;
        $query[$i]{"Longitude"} = $2;
        $query[$i]{"Latitude"}  = $3;
        $query[$i]{"Height"}    = $4;
        $query{"nstations"}     = $i+1;
    } elsif ($query{'LoadingType'} eq 'displacement' and
                  $line =~ /\s*(.+)\s+($NUM)\s+($NUM)/) {
        $query[$i]{"Name"}      = $1;
        $query[$i]{"Longitude"} = $2;
        $query[$i]{"Latitude"}  = $3;
        $query[$i]{"Height"}    = 0.0;
        $query{"nstations"}     = $i+1;
    }
    return 1;
}

sub get_sender {
    my $email = $_[0];
    our (@query,%query);
    foreach (split (/\n/, $email)) {
        if (/Return-Path:\s*<(.+)>.*/) { $query{'MyEmail'} = $1;}
    }
    return 1;
}
    
sub get_variables {
    my  $email = $_[0];
    my  ($special, $i);
    our (@query,%query);

    $special = 0;
    $query{'nstations'} = 0;
    foreach (split (/\n/, $email)) {
        if (/CMC\s*=\s*(\d)/)          { $query{'CMC'}   = $1;}
	if (/Model\s*=\s*([\w.]+)/)    { $query{'Model'} = $1;}
	if (/LoadingType\s*=\s*(\w+)/) { $query{'LoadingType'} = $1;}
	if (/OutputFormat\s*=\s*(\w+)/){ $query{'OutputFormat'}= $1;}
	if (/MyEmail\s*=\s*(.+)\s*/) { $query{'MyEmail'} = $1; $special=0;}
	if (/Stations\s*=\s*(.*)/) { 
	    &get_stations($1); 
	    $special=1;
	} elsif ($special == 1) { 
	    &get_stations($_);
	} 
    }
    return 1;
}


sub ParseMail {
    my     $filename = $_[0];
    my    ($email,$file, $file_new);
    my     $request=0;
    our   (@query,%query);

    $file = "";
    $file_new = "";
    open (MAILBOX,"<$filename") or die "Can't find mailbox: $!\n";
    while (<MAILBOX>) {
        $file .= $_;
    }
    close(MAILBOX);

    foreach $email (split (/^From /m, $file)) {
        if ($email =~ /Header\s*=\s*---- Ocean loading values follow next: ----/ and
	    $request == 0) {
            &get_variables($email);
	    $request = 1;
        } elsif ( $email =~ /Header\s*=\s*---- Knock knock ----/ and
	    $request == 0) {
            &get_sender($email);
            print STDERR "Mailing $query{'MyEmail'}\n";
            $request = 2;
        } else {
	    if ($email =~ /\w+/) {
                $file_new .= "From $email";
            }
	}
    }
    if ($request >= 1) {
        open (MAILBOX,">$filename") or die "Can't find mailbox: $!\n";
 	print MAILBOX $file_new;
        close(MAILBOX);
    }
    return $request;
}

sub Create_olfg_input {
    my ($i,$model,@components,$HARM,$shortname,$longname);
    my @harmonics = qw (m2 s2 n2 k2 k1 o1 p1 q1 Mf Mm Ssa);
    my %model = ('Schwiderski' => 'SCHW',
		 'FES94.1'     => 'FES94.1',
		 'FES95.2'     => 'FES95.2',
		 'FES98'       => 'FES98',
		 'FES99'       => 'FES99',
		 'CSR3.0'      => 'CSR3.0_f',
		 'CSR4.0'      => 'CSR4.0_f',
		 'NAO.99b'     => 'NAO.99b',
		 'TPXO.5'      => 'TPXO.5',
		 'TPXO.6.2'    => 'TPXO.6.2',
		 'GOT99.2b'    => 'GOT99.2b',
		 'GOT00.2'     => 'GOT00.2');
    our (@query,%query);

    open (JOB,">olfg.ins") or die "Can't create job file: $!\n";
    print JOB " &forms\n";        # ATTENTION!! space before &forms is necessary....
    print JOB " commnt='",$query{'Model'},"'\n";
    if ($query{'OutputFormat'} eq 'HARPOS') {
        print JOB " blqopt='h'\n";
    } 
    print JOB " XCPprint=.false.\n";
    print JOB " QHGHT=.true.\n";
    print JOB " &end\n";
    print JOB "41 B olfg.results\n";
    print JOB "42 B loading_c.dat\n";
    print JOB "43 B loading_i.dat\n";
    print JOB "44 B loading.xtb\n";
    print JOB "   C ",$query{'MyEmail'},"\n";
    print JOB "   Q \n";
    print JOB "$query{'nstations'} sites\n";
    print JOB "-/ XC_ON FMT \'(3x,a24,a1,f16.4,f16.4,f16.4)\'\n";
    for ($i=0;$i<$query{'nstations'};$i++) {
        $shortname = substr($query[$i]{"Name"},0,12);
        $longname = substr($query[$i]{"Name"},0,24);
        printf JOB (">  %-24s %16.4f%16.4f%16.4f\n", 
#            $shortname,$query[$i]{"Longitude"},
            $longname,$query[$i]{"Longitude"},
            $query[$i]{"Latitude"},$query[$i]{"Height"});
    }
    if ($query{'LoadingType'} eq 'displacement') {
        @components = qw (RADI TANG);
    } elsif ($query{'LoadingType'} eq 'gravity') {
        @components = qw (GRAV);
    } else { 
        @components = qw (TILT);
    }
    foreach my $comp (@components) {
        $model = $model{$query{'Model'}};
        print JOB "GREEN  C=$comp F=~/mc00egbc\n";
        foreach my $harm (@harmonics) {
            if ($harm !~ /Mf|Mm|Ssa/) {
                $HARM = uc $harm;
            } else {
                $HARM = $harm;
            }
            print JOB "DO TIDE $HARM ";
            if ($harm =~ /m2/) {
                print JOB "M=NCDF\$ F=/home/loading/tide-models/netCDF/$model\$ C=$model \n";
            } else {
                print JOB "\n";
            }
        }
    }
    print JOB "OUT\nSTOP\n";
    close(JOB);
}


sub print_HAR_header {
    my  ($model);
    our (@query,%query);

    print FH <<"EOF";
To: $query{'MyEmail'}
Subject: Ocean loading values results
From : Loading
Content-type: text/plain

HARPOS Format version of 2002.12.12
#
# Calculated on Ore using olfg/olmpp of H.-G. Scherneck
#
#============================ Beginning of comments: ==========================
#
EOF
    if ($query{'LoadingType'} eq 'displacement') {
        print FH "# This file contains site displacements caused by ocean tide loading.\n";
    } elsif ($query{'LoadingType'} eq 'gravity') {
        print FH "# This file contains gravity ocean tide loading values. Unit is mGal\n";
        print FH "# and is positive upwards.\n";
    } elsif ($query{'LoadingType'} eq 'tilt') {
        print FH "# This file contains tilt ocean tide loading values. Tilt is defined\n";
        print FH "# positive in North and East direction\n";
    }
    print FH <<"EOF";
#
# The phase lag is relative to Greenwich and lags positive. The 
# Gutenberg-Bullen Green's function is used. In the ocean tide model the 
# deficit of tidal water mass has been corrected by subtracting a uniform 
# layer of water with a certain phase lag globally.
#
# Complete <model name> : No interpolation of ocean model was necessary
# <model name>_PP       : Ocean model has been interpolated near the station 
#                         (PP = Post-Processing)
#
EOF
    if ($query{'CMC'} eq '1') {
        print FH "# CMC:  YES  (corr.tide centre of mass)\n#\n"; 
    }
    $model = $query{'Model'};
    if ($model =~ /CSR3.0|CSR4.0|FES95.2|GOT99.2b|GOT00.2/) {
        $model .= ", long period tides from FES99";
    } elsif ($model =~ /TPXO.5|TPXO.6.2/) {
        $model .= ", for harmonic Ssa the model FES99 is used";
    }
    print FH "# Ocean tide model: $model\n#\n";
    print FH <<"EOF";
#============================ End of comments: =================================
#
#  Harmonic   Phase          Frequency           Acceleration
#
H  m2         2.169437D+00   1.405189027044D-04   1.240D-23
H  s2         6.283185D+00   1.454441043329D-04  -7.350D-40
H  n2         6.097067D+00   1.378796996516D-04  -1.860D-23
H  k2         3.506941D+00   1.458423171028D-04   2.130D-24
H  k1         3.324267D+00   7.292115855138D-05   1.060D-24
H  o1         5.128356D+00   6.759774415297D-05   1.130D-23
H  p1         2.958919D+00   7.252294578148D-05  -1.060D-24
H  q1         2.772800D+00   6.495854110023D-05  -1.970D-23
H  mf         4.479096D+00   5.323414398410D-06  -1.030D-23
H  mm         5.497148D+00   2.639203052741D-06   3.100D-23
H  ssa        3.653480D-01   3.982127698995D-07   2.130D-24
#
#EH
EOF
}


sub print_BLQ_header {
    my  ($model);
    our (@query,%query);

    print FH <<"EOF";
To: $query{'MyEmail'}
Subject: Ocean loading values results
From : Loading
Content-type: text/plain

\$\$ Ocean loading $query{'LoadingType'}
\$\$
\$\$ Calculated on Ore using olfg/olmpp of H.-G. Scherneck
\$\$
\$\$ COLUMN ORDER:  M2  S2  N2  K2  K1  O1  P1  Q1  MF  MM SSA
\$\$
\$\$ ROW ORDER:
EOF
    if ($query{'LoadingType'} eq 'displacement') {
        print FH <<"EOF";
\$\$ AMPLITUDES (m)
\$\$   RADIAL
\$\$   TANGENTL    EW
\$\$   TANGENTL    NS
\$\$ PHASES (degrees)
\$\$   RADIAL
\$\$   TANGENTL    EW
\$\$   TANGENTL    NS
\$\$
\$\$ Displacement is defined positive in upwards, South and West direction.
EOF
    } elsif ($query{'LoadingType'} eq 'gravity') {
        print FH <<"EOF";
\$\$ AMPLITUDES (mGal)
\$\$   RADIAL
\$\$  PHASES (degrees)
\$\$   RADIAL
\$\$
\$\$ Gravity is defined positive upwards.
EOF
    } elsif ($query{'LoadingType'} eq 'tilt') {
        print FH <<"EOF";
\$\$ AMPLITUDES (mas)
\$\$   TANGENTL    EW
\$\$   TANGENTL    NS
\$\$ PHASES (degrees)
\$\$   TANGENTL    EW
\$\$   TANGENTL    NS
\$\$
\$\$ Tilt is defined positive in North and East direction.
EOF
    }
    print FH <<"EOF";
\$\$ The phase lag is relative to Greenwich and lags positive. The 
\$\$ Gutenberg-Bullen Green's function is used. In the ocean tide model the 
\$\$ deficit of tidal water mass has been corrected by subtracting a uniform 
\$\$ layer of water with a certain phase lag globally.
\$\$
\$\$ Complete <model name> : No interpolation of ocean model was necessary
\$\$ <model name>_PP       : Ocean model has been interpolated near the station 
\$\$                         (PP = Post-Processing)
\$\$ 
EOF
    if ($query{'CMC'} eq '1') {
        print FH "\$\$ CMC:  YES  (corr.tide centre of mass)\n\$\$\n"; 
    }
    $model = $query{'Model'};
    if ($model =~ /CSR3.0|CSR4.0|FES95.2|GOT99.2b|GOT00.2/) {
        $model .= ", long period tides from FES99";
    } elsif ($model =~ /TPXO.5|TPXO.6.2/) {
        $model .= ", for harmonic Ssa the model FES99 is used";
    }
    print FH "\$\$ Ocean tide model: $model\n\$\$\n";
    print FH "\$\$ END HEADER\n";
}


sub Create_olcmc_input {
    my   $model;
    our  %query;
 
    open (FH,">olcmc.ins") or die "Can't open olcmc.ins, $!\n";
    $model = $query{'Model'};
    print FH "$model>\n20 o header.txt\n21 o loading_c.dat\n";
    print FH "23 o ./CMC/$model.cmc\n31 b loading_cmc.dat\n";
    printf FH "   q\n(2x,a,t13,a9)\n";
    close (FH);
} 

sub Create_knock_reply {
    our %query;
    my $now;

    $now = `date`;
    open (FH,">knock.out") or die "Can't open knock.out, $!\n";
    print FH "To: $query{'MyEmail'}\n";
    print FH "Subject: Knock knock\n";
    print FH "From : loading\n";
    print FH "Content-type: text/plain\n";
    print FH "\nOcean Loading Provider: Mail system was alive at $now\n";
    close (FH);
}

sub Create_header {
    our  %query;

    open (FH,">header.txt") or die "Can't open header.txt, $!\n";
    if ($query{'OutputFormat'} eq 'HARPOS') {
        print_HAR_header();
    } else {
        print_BLQ_header();
    }
    close (FH);
}

 
sub Create_nice_output {
    my   $fileout = $_[0];
    our  %query;

    if ($query{'CMC'} eq 0) {
        `cat header.txt loading_c.dat > $fileout`;
    } else {
        `cp loading_cmc.dat $fileout`;
    }
    if ($query{'OutputFormat'} eq 'HARPOS') {
       `echo 'HARPOS Format version of 2002.12.12' >> $fileout`;
    } else {
       `echo '\$\$ END TABLE' >> $fileout`;
    }
    `fgrep 'BAD SITE' olfg.prt >> $fileout`; 
}


sub Progress_report_to_logbook {
    my  $cmt = $_[0];
    my ($d,$line);
    our %query;

    open FH,">>logbook.txt" or die "Can't open logbook, $!\n";
    chomp($d = `date`);
    $line = "At $d $cmt starting for " . $query{'MyEmail'} . "\n";
    print FH $line;
    close(FH);    
}


sub Add_to_logbook() {
    my  ($d,$n,$line);
    our  %query;

    open FH,">>logbook.txt" or die "Can't open logbook, $!\n";
    $d = `date`;
    $n = sprintf "%4d",$query{'nstations'};
    $line = $query{'MyEmail'};
    $line .= " "x(40-length($line));
    if ($query{'CMC'} eq 1) {
        $line .= " CMC ";
    } else {
        $line .= "     ";
    }
    $line .= "$n stations on $d";
    print FH $line;
    close(FH);
}


sub Send_result {
    `/usr/sbin/sendmail -t < $_[0]`;
}


MAIN:
{
    my $now = time;
    my $filename = "/var/mail/".$ENV{'USER'};
    my $fileout  = "test.out";
    my (@s,$request,$cmnt);
    our @query;
    our %query;

    $request=1;
    $query{'OutputFormat'} = 'BLQ';               # initialise variable
    for (;;) {
        @s = stat $filename;
        if (($s[9] > $now) or ($request >= 1)){
	    $request = ParseMail ($filename);
            $now = time;
            if ($request == 1) {
                `rm -f loading*`;                # remove old results
		Create_olfg_input();             # create olfg.ins
                $cmnt = "olfg ";
		Progress_report_to_logbook ($cmnt);
                `nice nohup olfg !olfg.ins > olfg.prt`;        # execute loading program!
                @s = stat "loading_i.dat";
                if ($s[7] > 0){                  # there are incomplete stations
		    $cmnt = "olmpp";
                    Progress_report_to_logbook ($cmnt);
	            if ($query{'OutputFormat'} eq 'HARPOS') {
                        `nice nohup olmpp !olmpp_har.ins`;
                    } else {
                        `nice nohup olmpp !olmpp_blq.ins`;
                    }
                }
                Create_header();                  # create header file BEFORE olcmc!
                if ($query{'CMC'} eq 1){
                    Create_olcmc_input();         # create olcmc.ins
                    $cmnt = "olcmc";
		    Progress_report_to_logbook ($cmnt);
                    `echo "Problem" > loading_cmc.dat`; 
                    `nice nohup olcmc !olcmc.ins`;
                }
                Create_nice_output($fileout);
                Add_to_logbook();
                Send_result($fileout);
            }
            elsif ($request == 2){ 
                Create_knock_reply();
                          print STDERR "Mailing now\n"; 
                `/usr/sbin/sendmail -t < knock.out`;
            } 
        } else {
            sleep 120;
        }
    }
}
