(defun print-to-pdf ()
  (interactive)
  (ps-spool-buffer-with-faces)
  (switch-to-buffer "*PostScript*")
  (write-file "/tmp/tmp.ps")
  (kill-buffer "tmp.ps")
  (setq cmd (concat "ps2pdf14 /tmp/tmp.ps /cygdrive/c/hgs/temp/" (buffer-name) ".pdf"))
  (setq acr (concat "Acrobat \'c:\\hgs\\temp\\" (buffer-name) ".pdf\' &"))
  (setq cygfn (concat "Acrobat /cygdrive/c/hgs/temp/" (buffer-name) ".pdf &"))
  (shell-command cmd)
  (shell-command "rm /tmp/tmp.ps")
  (message acr)
  (shell-command acr)
  )
(defun f-newline-and-indent ()
"Fortran make continuation line"
 (interactive)
 (newline) (beginning-of-line) (insert "     &") (forward-char))
 
(defun f-ruler ()
"Fortran ruler"
 (interactive) (save-excursion
 (end-of-line) (newline) (insert
"c2345c789012345678901234567890123456789012345678901234567890123456789012.......|")))

(defun begin-figure ()
"Begin figure environment"
  (interactive) (insert "\\begin{figure}")(newline)
                (insert "\\epsfig{file=}")(newline)
                (insert "\\caption{\\label{}}")(newline)
                (insert "\\end{figure}")(newline)
                (previous-line 3))

(defun begin-clause ()
"Begin the begin"
  (interactive) (insert "\\begin{}")(backward-char))

(defun begin-table ()
"Begin table environment"
  (interactive) (insert "\\begin{table}")(newline)
                (insert "\\caption{}")(newline)
                (insert "\\begin{tabular}{ }")(newline)(newline)
                (insert "\\end{tabular}")(newline)
                (insert "\\end{table}")(newline)
                (previous-line 3))

(defun begin-itemize ()
"Begin itemize block"
  (interactive) (insert "\\begin{itemize}")(newline)
                (insert "\\item ")(newline)
                (insert "\\end{itemize}")(newline)
                (previous-line 2)(end-of-line))

(defun begin-enumerate ()
"Begin enumerate block"
  (interactive) (insert "\\begin{enumerate}")(newline)
                (insert "\\item ")(newline)
                (insert "\\end{enumerate}")(newline)
                (previous-line 2)(end-of-line))

(defun begin-eqnarray ()
"Begin equation array"
  (interactive) (insert "\\begin{eqnarray}")(newline)(newline)
                (insert "\\end{eqnarray}")(newline)
		(previous-line 2))

(defun begin-equation ()
"Begin equation"
  (interactive) (insert "\\begin{equation}")(newline)(newline)
                (insert "\\end{equation}")(newline)
		(previous-line 2))

(defun begin-equation-and-label ()
"Begin equation with label"
  (interactive) (insert "\\begin{equation}")(newline)(newline)
                (insert "\\end{equation}")(newline)
		(previous-line 3)(end-of-line)
                (insert "\\label{eq:}")(backward-char 1))

(defun users-2-home ()
"Update for unix 10"
 (interactive) (query-replace "/users" "/home" nil))

(defun tex-nice-latex-block ()
  "Creates an \\end{...} to match the last unclosed \\begin{...}."
  (interactive "*")
  (let ((new-line-needed (bolp))
        text indentation)
    (save-excursion
      (condition-case nil
          (tex-last-unended-begin)
        (error (error "Couldn't find unended \\begin")))
      (setq indentation (current-column))
      (re-search-forward "\\\\begin\\(\\s *{[^}\n]*}\\)")
      (setq text (buffer-substring (match-beginning 1) (match-end 1))))
    (insert ?\n)
    (insert "\\end" text)
    (insert ?\n)
    (previous-line 2)))

(defun insert-aa ()
"a-ring"
(interactive) (insert "{\\aa}"))

(defun insert-AA ()
"a-ring"
(interactive) (insert "{\\AA}"))

(global-set-key [button5] 'next-line)
(global-set-key [button4] 'previous-line)
(global-set-key "\M-oa" 'insert-aa)
(global-set-key "\M-oA" 'insert-AA)
(global-set-key "\M-m" 'set-mark-command)
(global-set-key "\010" 'delete-backward-char)
(global-set-key "\177" 'delete-backward-char)
(global-set-key "\M-O}" 'abort-recursive-edit)
(global-set-key "\M-OA" 'previous-line)
(global-set-key "\M-OB" 'next-line)
(global-set-key "\M-OD" 'backward-char)
(global-set-key "\M-OC" 'forward-char)
(global-set-key "\M-Oe" 'forward-sentence)
(global-set-key "\M-Oa" 'backward-sentence)
(global-set-key "\C-x\C-f" 'set-fill-column)
(global-set-key "\C-xf" 'find-file)
(global-set-key "\C-xl" 'what-line)
(global-set-key "\M-ol" 'goto-line)
(global-set-key "\M-on" 'f-newline-and-indent)
(global-set-key "\e\C-r" 'query-replace)
(global-set-key "\M-{" 'tex-insert-braces)
(global-set-key "\M-e" 'tex-nice-latex-block)
(global-set-key "\M-or" 'f-ruler)
(global-set-key "\M-oe" 'begin-eqnarray)
(global-set-key "\M-oq" 'begin-equation)
(global-set-key "\M-oQ" 'begin-equation-and-label)
(global-set-key "\M-ot" 'begin-table)
(global-set-key "\M-oI" 'begin-itemize)
(global-set-key "\M-oN" 'begin-enumerate)
(global-set-key "\M-of" 'begin-figure)
(global-set-key "\M-ou" 'users-2-home)
(global-set-key "\M-ob" 'begin-clause)

(setq longlines-auto-wrap nil)
(setq auto-fill-mode -1)

