#!/usr/bin/perl
$blq=0;
@phf  = ( 0, 2, 2, 2, 2, 1, 1, 1, 1, 0,  0,  0 );
@indx = ( 0, 1, 2, 5, 6, 3, 7, 4, 8, 9, 10, 11 ); 
$amf=1.e-6;
$ampl=7;
$phal=8;
$endl=8;
if ( $ARGV[0]=~/\-h/ )
{ 
    print "\nUSAGE:\n";
    print "            olg.pl blqfile\n\n";
    print "PURPOSE:\n";
    print "          Converts ocean loading gravity parameters\n";
    print "          from Automatic ocean loading provider format\n";
    print "          (a.k.a. BLQ) to TSOFT format\n\n";
    print "          Only one file can be processed at one time,\n";
    print "          and the file must be headered, i.e. the complete\n";
    print "          email that http://froste.oso.chalmers.se/loading\n";
    print "          upon a user request must be input.\n\n";
    print "          This procedure copes with the following variants:\n";
    print "          One-component    (Gravity only)\n";
    print "          Three-components (Gravity and Tilt)\n";
    print "          um/s**2 or mGal units\n\n";
    exit 
}

while (<>){
    chomp;
    if ( m|COLUMN ORDER:(.*)| )
    {
        $tt=$1;
	$tt=~s/\W(\S+)/s$1 /g;
	$tt=~s/MF/Mf/; 
	$tt=~s/MM/Mm/;
	$tt=~s/SSA/Ssa/;
	@t=( split(/ +/,$tt) )
    }
    if ( m|\$\$   TILT E| ){ $phal=10; $endl=11 }
    if ( m|END HEADER| ){ $blq=1; $nr=0; print "Tides: @t\n"; }
    if ( m|\(mGal| ){ $amf=1.e-5 }
    if ( $blq )
    {   $nr++;
        if ( $nr > $endl )
	{ 
	    print "Station $s long. $x lat. $y\n";
            for ($j=1;$j<12;$j++)
	    {
		$i=$indx[$j];
		$pv = -$p[$i]-$phf[$i]*$x;
		if ( $pv < -180 ){ $pv+= 360. }
		if ( $pv >  180 ){ $pv-= 360. }
		printf "%-8s: %16.4e%15.2f \n",$t[$i], $a[$i]*$amf, $pv 
	    }
	    $nr=1; 
	    $a = ( );  @p = ( ) 
	}
	if ( m|lon/lat:\s+(\S+)\s+(\S+)| )  { $x=$1; $y=$2 }
	if ( $_ =~ /^ / )
	{    
	    if ( $nr == 3 )
	    { 
		m|^..(.*)|; $s=$1
	    }
	    elsif ( $nr == $ampl )
	    {
		@a = ( @a, split(/ +/) )
	    }
	    elsif ( $nr == $phal )
	    {
		@p = ( @p, split(/ +/) )
	    }
	}
    }
}
exit

